<!DOCTYPE html> 
<html>
	<head>
		<meta charset="utf-8"/>
		<title>JsEOQ Load Model Tree Benchmark</title>
		<script src="../eoq2/util/logger.js"></script>
		<script src="../eoq2/query/query.js"></script>
		<script src="../eoq2/command/command.js"></script>
		<script src="../eoq2/eoq2.js"></script>
		<script src="../eoq2/command/result.js"></script>
		<script src="../eoq2/frame/frame.js"></script>
		<script src="../eoq2/event/event.js"></script>
		<script src="../eoq2/domain/domain.js"></script>
		<script src="../eoq2/serialization/serializer.js"></script>
		<script src="../eoq2/serialization/jsonserializer.js"></script>
		<script src="../eoq2/domain/remote/websocketdomain.js"></script>
		
		<script src="contrib/jquery/jquery-3.3.1.min.js"></script>

		<link rel="stylesheet" type="text/css" href="css/jseoqdemo.css" />
	</head> 
	<body onload="Start()">
		<h1>JsEOQ Load Model Tree Benchmark</h1>
		
		<div id="status" class="">
			Open objects: <a id="status_open_objects" class="">0</a><br/>
			Closed objects: <a id="status_closed_objects" class="">0</a><br/>
			Progress: <a id="status_progress" class="">0</a> %<br/>
			Time elapsed: <a id="status_time" class=""></a> ms
		</div>
		
		<div id="root" class="tree_element">
			<a id="root_label" class="tree_name"></a>
		</div>

		
		
		<script>
		//local data handlers
		function DisplayResources(value) {
			$('#resultArea').val(value.toString());
		}
		
		function CommandFailedCallBack(result) {
			console.log("Error:");
			console.log(result);
		}
		
		var showTree = true; //set to false for time measurements
		
		var nOpenObjects = 0;
		var nClosedObjects = 0;
		var startTime = new Date();
		
		function UpdateStatus() {
			var updateTime = new Date();
			$("#status_open_objects").html(nOpenObjects);
			$("#status_closed_objects").html(nClosedObjects);
			$("#status_progress").html((nClosedObjects/nOpenObjects)*100);
			$("#status_time").html(updateTime-startTime);
		}
		
		function RetrieveFullResourceTrees(domain) {
			//Retrieve all resources available
			$('#root_label').html(domain._url);
			let cmd = CMD.Get(QRY.Pth('resources').Pth('name'));
			domain.Do(cmd).then(function(value) {
					for(var i=0;i<value.length;i++) {
						var name = value[i];
						if(showTree) {
							var root = $('#root');
							root.append('<div id="resource'+i+'" class="tree_element">'+
										'	<a id="resource'+i+'_label" class="tree_name">'+name+'</a>' +
										'</div>');
						}
					}
					//Do it only for one
					RetrieveResourceRoots(domain,'MinimalFlightControl.oaam',0);
			});
		}
		
		function RetrieveResourceRoots(domain,resourceName,resourceNumber) {
			let cmd = CMD.Get(new QRY.Pth('resources').Sel(
											QRY.Pth('name').Equ(resourceName)).Idx(0).Pth('contents').Idx(0)
							 );
			domain.Do(cmd).then(function(value) {
				//for(var i=0;i<value.length;i++) {
					var name = value.v; //get the id of the element;
					if(showTree) {
						var root = $('#resource'+resourceNumber);
						root.append('<div id="object'+name+'" class="tree_element">'+
									'	<a id="object'+name+'_label" class="tree_name">#'+name+'</a>' +
									'</div>');
					}
								
					RetrieveObjectContainments(domain,value,name);
				//}
			});
		}
		
		function RetrieveObjectContainments(domain,obj,objId) {
			let cmd = CMD.Cmp().
					Get(QRY.Qry(obj).Met('CONTAINMENTNAMES')).
					Get(QRY.Qry(obj).Met('CONTAINMENTVALUES'))
			domain.Do(cmd).then(function(value) {
					var containmentnames = value[0];//return values is composed of two arrays of equal length
					var containmentvalues = value[1];
					var nContainments = containmentnames.length;
					for(var i=0;i<nContainments;i++) {
						var containmentname = containmentnames[i]; //get the id of the element;
						var containmentvalue = containmentvalues[i];
						
						if(showTree) {
							var root = $('#object'+objId);
							root.append('<div id="object'+objId+'_'+containmentname+'" class="tree_element">'+
										'	<a id="object'+objId+'_'+containmentname+'_label" class="tree_name">#'+containmentname+'</a>' +
										'</div>');
						}
						
						if(!(containmentvalue instanceof Array)) {
							containmentvalue = [containmentvalue];
						}
						for(var j=0;j<containmentvalue.length;j++) {
							if(containmentvalue[j]) {
								containedObj = containmentvalue[j];
								nOpenObjects++;
								var containedObjId = containedObj.v; //get the id of the element;
								if(showTree) {
									var root = $('#object'+objId+'_'+containmentname);
									root.append('<div id="object'+containedObjId+'" class="tree_element">'+
												'	<a id="object'+containedObjId+'_label" class="tree_name">#'+containedObjId+'</a>' +
												'</div>');
								}
								
								RetrieveObjectContainments(domain,containedObj,containedObjId);
								
								nClosedObjects++;
								UpdateStatus();
							}
						}
					}
				}
			);
		}
		
		
		function Start() {
			//start execution
			var webSocketUrl = 'ws://localhost:8000/ws/eoq.do'
			
			//initialize the domain
			var domain = new eoq2.domain.remote.WebSocketDomain(webSocketUrl,logger=new eoq2.util.NoLogging());
			
			domain.Open().then(function(value) {
				RetrieveFullResourceTrees(domain);
			});
		}
		
		
		</script>
	</body>
</html>